package com.aspose.demo;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import com.aspose.slides.*;

import java.net.URL;

public class JavaPPT extends HttpServlet {

    private static final String CONTENT_TYPE = "text/html; Latin-1";

    //Initialize global variables
    public void init() throws ServletException {
    }

    //Process the HTTP Get request
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        response.setContentType(CONTENT_TYPE);
        PrintWriter out = response.getWriter();
        out.println("<html>");
        out.println("<HEAD>\n" +
                "<title>Aspose.Slides - Aspose.Slides Free Download PowerPoint presentation " +
                "slide binary file format reader writer report generate create PPT Microsoft " +
                "Office Java DotNet .Net C# VB vb.net J# Asp.Net aspx Api component class object " +
                "library</title>\n" +
                "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n" +
                "<link href=\"http://www.aspose.com/aspose2005.css\" type=\"text/css\" rel=\"stylesheet\">\n" +
                "</HEAD>");

        out.println("<body background=\"http://www.aspose.com/images/imgBack.gif\">");

        String header = "<table style=\"BORDER-LEFT-WIDTH: 0px\" borderColor=\"#000080\" cellSpacing=\"0\" cellPadding=\"0\" width=\"100%\" bgColor=\"#ffffff\" border=\"0\">\n" +
                "\t<tr>\n\t\t<td width=\"300\" style=\"border-left-style: solid; border-left-width: 1px; border-right-width: 1px; border-top-style: solid; border-top-width: 1px; border-bottom-width: 1px\">\n" +
                "\t\t\t<img border=\"0\" src=\"http://www.aspose.com/images/imgLogo.gif\" width=\"300\" height=\"69\">\n" +
                "\t\t</td>\n\t\t<td width=\"30%\" background=\"http://www.aspose.com/images/1x1.gif\" style=\"border-left-width: 1px; border-top-style: solid; border-top-width: 1px; border-bottom-width: 1px\">\n" +
                "\t\t\t&nbsp;\n\t\t</td>\n" +
                "\t\t<td width=\"460\" align=right background=\"http://www.aspose.com/images/imgPattern.gif\" style=\"border-left-width: 1px; border-right-style: solid; border-right-width: 1px; border-top-style: solid; border-top-width: 1px; border-bottom-width: 1px\">\n" +
                "\t\t\t&nbsp;\n\t\t</td>\n\t</tr>\n\t<tr>\n" +
                "\t\t<td colspan=\"3\" bgcolor=\"#000080\" align=\"center\" class=\"topnav\" style=\"border-left-style: solid; border-left-width: 1px; border-right-style: solid; border-right-width: 1px; border-top-width: 1px; border-bottom-width: 1px\" height=\"20\">\n" +
                "\t\t\t<a href=\"http://www.aspose.com/\">Home</a> \u0007\n\t\t\t<a href=\"http://www.aspose.com/Products/\">Products</a> \u0007 \n" +
                "\t\t\t<a href=\"http://www.aspose.com/Purchase/\">Purchase</a> \u0007 \n\t\t\t<a href=\"http://www.aspose.com/Downloads/\">Downloads</a> \u0007 \n" +
                "\t\t\t<a href=\"http://www.aspose.com/Demos/\">Demos</a> \u0007 \n\t\t\t<a href=\"http://www.aspose.com/Forums/\">Forums</a> \u0007\n" +
                "\t\t\t<a href=\"http://www.aspose.com/Blogs/\">Blogs</a> \u0007 \n\t\t\t<a href=\"http://www.aspose.com/Ticket/\">Ticket</a> \u0007 \n" +
                "\t\t\t<a href=\"http://www.aspose.com/Wiki/\">Wiki</a> \u0007 \n\t\t\t<a href=\"http://www.aspose.com/API/\">API</a> \u0007 \n" +
                "\t\t\t<a href=\"http://www.aspose.com/Corporate/\">Corporate</a>\n\t\t</td>\n\t</tr>\n</table>";

        out.println(header);
        out.println("<p class=\"i1\">Welcome to the <STRONG>Aspose.Slides for Java Featured Demos</STRONG>!</p>");
        out.println("<P class=\"i1\">&nbsp;</P>");
        out.println("<P class=\"i1\">The demo loads PowerPoint presentation, modifies and displayes it</p> ");
        out.println("<FORM METHOD=POST>");
        out.println("<INPUT TYPE=SUBMIT VALUE=\"Run DEMO\">");
        out.println("</FORM");
        //	out.println("<p>The servlet has received a " + request.getMethod() + ". This is the reply.</p>");

        String footer = "<div id=\"footer\">" +
                "<P><A href=\"http://www.aspose.com/Corporate/Aspose/Contactaspose.html\">We guarantee a prompt response to any inquiry!</A></P>" +
                "<p></p></body></HTML>";
        out.println(footer);
    }

    //Process the HTTP Post request
    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        Presentation pres;

        FileInputStream source = null;
        FileOutputStream destination = null;
        PrintStream dataOut = null;
        DataInputStream dataIn;

        try {
            ServletContext context = request.getSession().getServletContext();
            String realContextPath = context.getRealPath(request.getContextPath());

            int pos = realContextPath.lastIndexOf("\\");
            realContextPath = realContextPath.substring(0, pos);

            String pptPath = realContextPath + "\\" + "demo.ppt";
            String destPath = realContextPath + "\\" + "demo_new.ppt";
            source = new FileInputStream(pptPath);
            destination = new FileOutputStream(destPath);

            pres = new Presentation(source);

            Slides slides = pres.getSlides();
            for (int i = 0; i < slides.size(); i++) {
                // Set text of standard slide placeholders
                Placeholders pholders = slides.get(i).getPlaceholders();
                for (int j = 0; j < pholders.size(); j++) {
                    if (pholders.get(j) instanceof TextHolder) {
                        TextHolder th = (TextHolder) pholders.get(j);
                        if (th.getText().equals("H1"))
                            th.getParagraphs().get(0).getPortions().get(0).setText("Demo Presentation");
                        else if (th.getText().equals("SH1"))
                            th.getParagraphs().get(0).getPortions().get(0).setText("Aspose.Slides.Template");
                        else if (th.getText().equals("T1")) {
                            switch (i) {
                                case 1:
                                    th.getParagraphs().get(0).getPortions().get(0).setText("With Aspose.Slides you can:\rOpen, read and save Microsoft PowerPoint presentations.");
                                    break;
                                case 2:
                                    th.getParagraphs().get(0).getPortions().get(0).setText("With Aspose.Slides you can:\rChange standard text placeholders as well as custom text frames.");
                                    break;
                                case 3:
                                    th.getParagraphs().get(0).getPortions().get(0).setText("With Aspose.Slides you can:\rReplace background pictures with any picture from presentation or new picture.");
                                    break;
                            }
                        }
                    }
                }

                // Set text for text frames
                Shapes shapes = slides.get(i).getShapes();
                for (int j = 0; j < shapes.size(); j++) {
                    TextFrame tf = shapes.get(j).getTextFrame();
                    if (tf != null) {
                        if (tf.getText().equals("CT1"))
                            tf.getParagraphs().get(0).getPortions().get(0).setText("Created on:");
                        else if (tf.getText().equals("CT2"))
                            tf.getParagraphs().get(0).getPortions().get(0).setText(new Date().toString());
                        else if (tf.getText().equals("P1")) {
                            tf.getParagraphs().get(0).getPortions().get(0).setText("Slide " + (i + 1));
                        }
                    }
                }
            }

            pres.write(destination);
            source.close();
            destination.close();

            String servletPath = request.getRequestURL().toString();
            pos = servletPath.lastIndexOf("/");
            String pptDemoPath = servletPath.substring(0, pos) + "/" + "demo_new.ppt";

            ServletOutputStream out = response.getOutputStream();

            response.setContentType("application/vnd.ms-powerpoint");
            response.addHeader("Content-Disposition", "attachment; filename=demo_new.ppt");

            BufferedInputStream bis = null;
            BufferedOutputStream bos = null;

            URL url = new URL(pptDemoPath);

            // Use Buffered Stream for reading/writing.
            bis = new BufferedInputStream(url.openStream());
            bos = new BufferedOutputStream(out);

            byte[] buff = new byte[2048];
            int bytesRead;

            // Simple read/write loop.
            while (-1 != (bytesRead = bis.read(buff, 0, buff.length))) {
                bos.write(buff, 0, bytesRead);
            }

            bis.close();
            bos.flush();
            bos.close();

            response.flushBuffer();
        } catch (Exception e) {
            response.setContentType("text/html");
            PrintWriter out = response.getWriter();
            out.println("<HTML>");
            out.println("<HEAD>");
            out.println("<TITLE>The POST method</TITLE>");
            out.println("</HEAD>");
            out.println("<BODY>");
            out.println("The servlet has an exception<br>");
            out.println(e.getMessage());
            out.println("</BODY>");
            out.println("</HTML>");
        }
    }

    //Clean up resources
    public void destroy() {
    }
}
